#include <cstdio>
#include <cstdlib>
#include <vector>
#include "goat.h"

static void ASSERT(bool p, const char* str)
{
  if(!p)
  {
    fprintf(stderr, "%s\n", str);
    exit(1);
  }
}
int main()
{
  int N; ASSERT(1==scanf("%d", &N), "invalid N");
  int Q; ASSERT(1==scanf("%d", &Q), "invalid Q");
  std::vector<int> X, Y;
  for(int i=0; i<N; ++i)
  {
    int xi, yi; ASSERT(2==scanf("%d%d", &xi, &yi), "invalid coordinate");
    X.push_back(xi); Y.push_back(yi);
  }
  init(X, Y);
  for(int i=0; i<Q; ++i)
  {
    int a, b, c; ASSERT(3==scanf("%d%d%d", &a, &b, &c), "invalid query");
    printf("%d\n", count(a, b, c));
  }
  return 0;
}
